---
title: Wiki Bastionado
description: ¡Bienvenido a la Wiki de Bastionado!
published: true
date: 2022-05-18T11:36:28.208Z
tags: 
editor: markdown
dateCreated: 2022-05-18T11:36:28.208Z
---

# ¿Qué objetivos deberás ser capaz de superar al finalizar la asignatura?
## 1. Diseña planes de securización incorporando buenas prácticas para el bastionado de sistemas y redes
* Se han identificado los activos, las amenazas y vulnerabilidades de la organización.
* Se ha evaluado las medidas de seguridad actuales.
* Se ha elaborado un análisis de riesgo de la situación actual en ciberseguridad de la organización
* Se ha priorizado las medidas técnicas de seguridad a implantar en la organización teniendo también en cuenta los principios de la Economía Circular.
* Se ha diseñado y elaborado un plan de medidas técnicas de seguridad a implantar en la organización, apropiadas para garantizar un nivel de seguridad adecuado en función de los riesgos de la organización.
* Se han identificado las mejores prácticas en base a estándares, guías y políticas de securización adecuadas para el bastionado de los sistemas y redes de la organización.
---
## 2. Configura sistemas de control de acceso y autenticación de personas preservando la confidencialidad y privacidad de los datos
* Se han definido los mecanismos de autenticación en base a distintos / múltiples factores (físicos, inherentes y basados en el conocimiento), existentes.
* Se han definido protocolos y políticas de autenticación basados en contraseñas y frases de paso, en base a las principales vulnerabilidades y tipos de ataques.
* Se han definido protocolos y políticas de autenticación basados en certificados digitales y tarjetas inteligentes, en base a las principales vulnerabilidades y tipos de ataques.
* Se han definido protocolos y políticas de autenticación basados en tokens, OTPs, etc., en base a las principales vulnerabilidades y tipos de ataques.
* Se han definido protocolos y políticas de autenticación basados en características biométricas, según las principales vulnerabilidades y tipos de ataques.
---
## 3. Administra credenciales de acceso a sistemas informáticos aplicando los requisitos de funcionamiento y seguridad establecidos
* Se han identificado los tipos de credenciales más utilizados.
* Se han generado y utilizado diferentes certificados digitales como medio de acceso a un servidor remoto.
* Se ha comprobado la validez y la autenticidad de un certificado digital de un servicio web.
* Se han comparado certificados digitales válidos e inválidos por diferentes motivos.
* Se ha instalado y configurado un servidor seguro para la administración de credenciales (tipo RADIUS – Remote Access Dial In User Service)
---
## 4. Diseña redes de computadores contemplando los requisitos de seguridad
* Se ha incrementado el nivel de seguridad de una red local plana segmentándola físicamente y utilizando técnicas y dispositivos de enrutamiento.
* Se ha optimizado una red local plana utilizando técnicas de segmentación lógica (VLANs).
* Se ha adaptado un segmento de una red local ya operativa utilizando técnicas de subnetting para incrementar su segmentación respetando los direccionamientos existentes.
* Se han configurado las medidas de seguridad adecuadas en los dispositivos que dan acceso a una red inalámbrica (routers, puntos de acceso, etc.).
* Se ha establecido un túnel seguro de comunicaciones entre dos sedes geográficamente separadas.
---
## 5. Configura dispositivos y sistemas informáticos cumpliendo los requisitos de seguridad
* Se han configurado dispositivos de seguridad perimetral acorde a una serie de requisitos de seguridad.
* Se han detectado errores de configuración de dispositivos de red mediante el análisis de tráfico.
* Se han identificado comportamientos no deseados en una red a través del análisis de los registros (Logs), de un cortafuego.
* Se han implementado contramedidas frente a comportamientos no deseados en una red.
* Se han caracterizado, instalado y configurado diferentes herramientas de monitorización.
---
## 6. Configura dispositivos para la instalación de sistemas informáticos minimizando las probabilidades de exposición a ataques
* Se ha configurado la BIOS para incrementar la seguridad del dispositivo y su contenido minimizando las probabilidades de exposición a ataques.
* Se ha preparado un sistema informático para su primera instalación teniendo en cuenta las medidas de seguridad necesarias.
* Se ha configurado un sistema informático para que un actor malicioso no pueda alterar la secuencia de arranque con fines de acceso ilegítimo.
* Se ha instalado un sistema informático utilizando sus capacidades de cifrado del sistema de ficheros para evitar la extracción física de datos.
* Se ha particionado el sistema de ficheros del sistema informático para minimizar riesgos de seguridad.
---
## 7. Configura sistemas informáticos minimizando las probabilidades de exposición a ataques
* Se han enumerado y eliminado los programas, servicios y protocolos innecesarios que hayan sido instalados por defecto en el sistema.
* Se han configurado las características propias del sistema informático para imposibilitar el acceso ilegítimo mediante técnicas de explotación de procesos.
* Se ha incrementado la seguridad del sistema de administración remoto SSH y otros.
* Se ha instalado y configurado un Sistema de detección de intrusos en un Host (HIDS) en el sistema informático.
* Se han instalado y configurado sistemas de copias de seguridad.
---
# ¿Qué conceptos y contenidos básicos vas a aprender en la asignatura?
A continuación, un breve repaso de todas las temáticas que vas a enseñarte en la realización de la asignatura de bastionado en redes y sistemas.

* Aprenderás a diseñar planes de securización
* Análisis de riesgos.
* Principios de la Economía Circular en la Industria 4.0.
* Plan de medidas técnicas de seguridad.
* Políticas de securización más habituales.
* Guías de buenas prácticas para la securización de sistemas y redes.
* Estándares de securización de sistemas y redes.
* Caracterización de procedimientos, instrucciones y recomendaciones.
* Niveles, escalados y protocolos de atención a incidencias.
* Aprenderás a configurar sistemas de control de acceso y autenticación de personas:
* Mecanismos de autenticación. Tipos de factores.
* Autenticación basada en distintas técnicas:
* Aprenderás a administrar credenciales de acceso a sistemas informáticos
* Gestión de credenciales.
* Infraestucturas de Clave Pública (PKI).
* Acceso por medio de Firma electrónica.
* Gestión de accesos. Sistemas NAC (Network Access Control, Sistemas de Gestión de Acceso a la Red).
* Gestión de cuentas privilegiadas.
* Protocolos RADIUS y TACACS, servicio KERBEROS, entre otros.
* Aprenderás a diseñar redes de computadores seguras
* Segmentación de redes.
* Subnetting.
* Redes virtuales (VLANs).
* Zona desmilitarizada (DMZ).
* Seguridad en redes inalámbricas (WPA2, WPA3, etc.).
* Protocolos de red seguros (IPSec, etc.).
* Aprenderás a configurar la seguridad en dispositivos y sistemas informáticos
* Seguridad perimetral. Firewalls de Próxima Generación.
* Seguridad de portales y aplicativos web. Soluciones WAF (Web Aplication Firewall).
* Seguridad del puesto de trabajo y endpoint fijo y móvil. AntiAPT, antimalware.
* Seguridad de entornos cloud. Soluciones CASB.
* Seguridad del correo electrónico
* Soluciones DLP (Data Loss Prevention)
* Herramientas de almacenamiento de logs.
* Protección ante ataques de denegación de servicio distribuido (DDoS).
* Configuración segura de cortafuegos, enrutadores y proxies.
* Redes privadas virtuales (VPNs), y túneles (protocolo IPSec).
* Monitorización de sistemas y dispositivos.
* Herramientas de monitorización (IDS, IPS).
* SIEMs (Gestores de Eventos e Información de Seguridad).
* Soluciones de Centros de Operación de Red, y Centros de Seguridad de Red: NOCs y SOCs.
* Aprenderás a configurar dispositivos para la instalación de sistemas informáticos
* Precauciones previas a la instalación de un sistema informático: aislamiento, configuración del control de acceso a la BIOS, bloqueo del * orden de arranque de los dispositivos, entre otros.
* Seguridad en el arranque del sistema informático, configuración del arranque seguro.
* Seguridad de los sistemas de ficheros, cifrado, particionado, entre otros.
* Aprenderás a configurar los sistemas informáticos
* Reducción del número de servicios, Telnet, RSSH, TFTP, entre otros.
* Hardening de procesos (eliminación de información de depuración en caso de errores, aleatorización de la memoria virtual para evitar exploits, etc.).
* Eliminación de protocolos de red innecesarios (ICMP, entre otros).
* Securización de los sistemas de administración remota.
* Sistemas de prevención y protección frente a virus e intrusiones (antivirus, HIDS, etc.).
* Configuración de actualizaciones y parches automáticos.
* Sistemas de copias de seguridad.
* Shadow IT y políticas de seguridad en entornos SaaS.
* ¿Cuáles son los objetivos pedagógicos finales de la asignatura?
* El diseño de planes de securización de la organización.
* El diseño de redes de computadores.
* La administración de los sistemas de control de acceso.
